%define debug_package %{nil}
%define product_family %{?_vendor:%{_vendor}}%{!?_vendor:openEuler}
%define variant_titlecase Server
%define variant_lowercase server
%define dist_release_version 8
%define generic_version 20.03
%define generic_patch_level LTS
%define generic_patch_level_extend SP3
%define generic_release 54
%define builtin_release_version 1.0

%define current_arch %{_arch}
%ifarch i386
%define current_arch x86
%endif

%global boot_args fpi_to_tail=off

Name:		%{product_family}-release
Version:	%{generic_version}%{generic_patch_level}_%{generic_patch_level_extend}
Release:	%{generic_release}
Summary:	%{product_family} release file
License:	Mulan PSL v2
Provides:	%{product_family}-release
Provides:	%{_vendor}-release
Provides:	generic-release
Provides:	system-release = %{generic_version}%{generic_patch_level}_%{generic_patch_level_extend}
Source0:	generic-release-%{builtin_release_version}.tar.gz
Source1:	85-display-manager.preset
Source2:	90-default.preset
Source3:	99-default-disable.preset

Source4:        dot-bashrc
Source5:        dot-bash_profile
Source6:        dot-bash_logout
Source7:        dot-tcshrc
Source8:        dot-cshrc

BuildRequires:	python
Requires:  %{product_family}-repos 
Requires:  %{product_family}-release-custom
Obsoletes: 	yum-utils yum-utils-help yum-utils-plugins

%description
%{product_family} release files

%package -n %{product_family}-performance
Requires:   coreutils systemd setup

Summary:         performance script
%description -n %{product_family}-performance
performance script

%package -n %{product_family}-rootfiles
Summary:         Basic required files for the root user's account
BuildArch:       noarch
Conflicts:       rootfiles

%description -n %{product_family}-rootfiles
The rootfiles package contains basic required files that are placed
in the root user's account. These files are basically the same as
those in /etc/skel, which are placed in regular users' home directories.

%package -n %{product_family}-release-custom
Summary:   openeuler-release-custom
BuildArch: noarch

%description -n %{product_family}-release-custom
openeuler-release-custom

%prep
%setup -q -n generic-release-%{builtin_release_version}

%postun -n %{product_family}-release-custom
vendorid=`lscpu | grep "Vendor ID:" | awk '{print $3}'`
model=`lscpu | grep "Model:" | awk '{print $2}'`

if [ "0x70" == "${vendorid}" -a "3" == "${model}" ]; then 
   grep "%{boot_args}" /etc/grub.d/10_linux > /dev/null 2>&1
   if [ $? -ne 0 ]; then
   echo "ERROR: failed to clean up boot args in /etc/grub.d/10_linux because they have been modified"
   exit 1
   fi
   sed -i "s/%{boot_args} //g" /etc/grub.d/10_linux 
fi

%posttrans -n %{product_family}-release-custom	

# parameters for grub2

vendorid=`lscpu | grep "Vendor ID:" | awk '{print $3}'`
model=`lscpu | grep "Model:" | awk '{print $2}'`

if [ "0x70" == "${vendorid}" -a "3" == "${model}" ]; then 
    sed -i "s/ ro .*args/ ro %{boot_args} \$\{args/g" /etc/grub.d/10_linux
fi

%build
echo OK

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc
echo "%{product_family} release %{generic_version} (%{generic_patch_level}-%{generic_patch_level_extend})" > $RPM_BUILD_ROOT/etc/%{product_family}-release
ln -sf %{product_family}-release $RPM_BUILD_ROOT/etc/system-release

# create /etc/os-release
cat << EOF >>$RPM_BUILD_ROOT/etc/os-release
NAME="%{product_family}"
VERSION="%{generic_version} (%{generic_patch_level}-%{generic_patch_level_extend})"
ID="%{product_family}"
VERSION_ID="%{generic_version}"
PRETTY_NAME="%{product_family} %{generic_version} (%{generic_patch_level}-%{generic_patch_level_extend})"
ANSI_COLOR="0;31"

EOF

mkdir -p -m 755 $RPM_BUILD_ROOT/etc/profile.d
cp -a color.sh $RPM_BUILD_ROOT/etc/profile.d/
cp -a system-info.sh $RPM_BUILD_ROOT/etc/profile.d/
cp -a performance.sh $RPM_BUILD_ROOT/etc/profile.d/

# write cpe to /etc/system/release-cpe
echo "cpe:/o:%{product_family}:%{product_family}:%{version}:ga:server" > $RPM_BUILD_ROOT/etc/system-release-cpe

# create /etc/issue and /etc/issue.net
echo '\S' > $RPM_BUILD_ROOT/etc/issue
echo 'Kernel \r on an \m' >> $RPM_BUILD_ROOT/etc/issue
cp $RPM_BUILD_ROOT/etc/issue $RPM_BUILD_ROOT/etc/issue.net
echo >> $RPM_BUILD_ROOT/etc/issue

mkdir -p $RPM_BUILD_ROOT/usr/share/eula
cp eula.[!py]* $RPM_BUILD_ROOT/usr/share/eula

mkdir -p $RPM_BUILD_ROOT/var/lib
cp supportinfo $RPM_BUILD_ROOT/var/lib/supportinfo

# set up the dist tag macros
install -d -m 755 $RPM_BUILD_ROOT/etc/rpm
cat >> $RPM_BUILD_ROOT/etc/rpm/macros.dist << EOF
# dist macros.

%%dist %%{nil}
%%%{product_family} 2
EOF

# use unbranded datadir
mkdir -p -m 755 $RPM_BUILD_ROOT/%{_datadir}/%{product_family}-release
install -m 644 EULA $RPM_BUILD_ROOT/%{_datadir}/%{product_family}-release

# use unbranded docdir
mkdir -p -m 755 $RPM_BUILD_ROOT/%{_docdir}/%{product_family}-release
cp -p License/LICENSE $RPM_BUILD_ROOT/%{_docdir}/%{product_family}-release

# copy systemd presets
mkdir -p %{buildroot}%{_prefix}/lib/systemd/system-preset/
install -m 0644 %{SOURCE1} %{buildroot}%{_prefix}/lib/systemd/system-preset/
install -m 0644 %{SOURCE2} %{buildroot}%{_prefix}/lib/systemd/system-preset/
install -m 0644 %{SOURCE3} %{buildroot}%{_prefix}/lib/systemd/system-preset/

# set root's bash profile
mkdir -p %{buildroot}/root

install -p -m 644 %{SOURCE4} %{buildroot}/root/.bashrc
install -p -m 644 %{SOURCE5} %{buildroot}/root/.bash_profile
install -p -m 644 %{SOURCE6} %{buildroot}/root/.bash_logout
install -p -m 644 %{SOURCE7} %{buildroot}/root/.tcshrc
install -p -m 644 %{SOURCE8} %{buildroot}/root/.cshrc

%posttrans -n %{product_family}-rootfiles
if [ $1 -eq 0 ] ; then
        cp -ndr --preserve=ownership,timestamps /etc/skel/. /root/ || :
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(0644,root,root,0755)
/etc/system-release
/etc/profile.d/color.sh
/etc/profile.d/system-info.sh
/etc/%{product_family}-release
%config(noreplace) /etc/os-release
%config /etc/system-release-cpe 
%config(noreplace) /etc/issue
%config(noreplace) /etc/issue.net
/etc/rpm/macros.dist
%{_docdir}/%{product_family}-release/*
%{_datadir}/%{product_family}-release/*
%{_prefix}/lib/systemd/system-preset/*
/var/lib/supportinfo
/usr/share/eula/eula.*

%files -n %{product_family}-performance
%defattr(0644,root,root,0755)
/etc/profile.d/performance.sh

%files -n %{product_family}-rootfiles
%config(noreplace) /root/.bashrc
%config(noreplace) /root/.bash_profile
%config(noreplace) /root/.bash_logout
%config(noreplace) /root/.tcshrc
%config(noreplace) /root/.cshrc

%files -n %{product_family}-release-custom

%changelog
* Tue Nov 8 2022 liyanan <liyanan32@h-partners.com> - 1.0-54
- fix release-custom uninstall error

* Tue Nov 8 2022 liyanan <liyanan32@h-partners.com> - 1.0-53
- sysconfig parameters have a impact on performance,comment out the relevant content

* Tue Dec 31 2021 Jiachen Fan <fanjiachen3@huawei.com> - 1.0-52
- delete release-custom install requires

* Tue Dec 31 2021 Jiachen Fan <fanjiachen3@huawei.com> - 1.0-51
- delete dependency bc

* Tue Dec 31 2021 chemingdao <chemingdao@huawei.com> - 1.0-50
- Bugfix: openenEuler-release-custom dnf error when openEuler installing.

* Tue Dec 31 2021 chemingdao <chemingdao@huawei.com> - 1.0-49
- init openeuler custom

* Thu Dec 30 2021 gaochong <gaochong@uniontech.com> - 1.0-48
- require bc for caculating free memory

* Tue Dec 21 2021 gaochong <gaochong@uniontech.com> - 1.0-47
- get memeroy info from /proc/meminfo instead of command free

* Wed Dec 01 2021 yaokai <yaokai13@huawei.com> - 1.0-46
- Fix syntax errors

* Mon Nov 22 2021 miao_kaibo <miaokaibo@outlook.com> - 1.0-45
- delete dependency bc 

* Tue Nov 16 2021 wangchong <wangchong56@huawei.com> - 1.0-44
- change to SP3 and add generic_patch_level_extend 

* Tue Sep 14 2021 wangce <wangce@uniontech.com> - 1.0-43
- amend root files

* Thu Aug 26 2021 wangxiaorou <wangxiaorou@uniontech.com> - 1.0-42
- fix system-info.sh syntax error

* Thu 24 Aug 2021 miao_kaibo <miaokaibo@outlook.com> - 1.0-41
- bugfix I468W9 

* Fri 09 Jul 2021 sunguoshuai <sunguoshuai@huawei.com> - 1.0-40
- modify system-info.sh to show more ip address when login
- /sbin/ip not found err fix

* Tue May 18 2021 solar.hu <solar.hu@foxmail.com> - 1.0-39
- Disable for GOMP issue with rpmbuild

* Thu Jan 7 2020 shenyangyang <shenyangyang4@huawei.com> - 1.0-38
- add %{product_family}-rootfiles package that contains the basic
  .bash* config for root user

* Mon May 18 2020 shenyangyang <shenyangyang4@huawei.com> - 1.0-37
- add equal sign in color.sh

* Fri May 15 2020 shenyangyang <shenyangyang4@huawei.com> - 1.0-36
- Add more default color

* Thu May 7 2020 shenyangyang <shenyangyang4@huawei.com> - 1.0-35
- Modify the license info in files

* Wed Apr 29 2020 shenyangyang <shenyangyang4@huawei.com> - 1.0-34
- Change license of mulan to v2

* Sat Mar 21 2020 songnannan <songnannan2@huawei.com> - 1.0-33
- add obsoletes the yum utils

* Thu Mar 19 2020 openEuler Buildteam <buildteam@openeuler.org> - 1.0-32
- change generic_release_1.0

* Wed Mar 18 2020 openEuler Buildteam <buildteam@openeuler.org> - 1.0-31
- change generic_version

* Tue Mar 17 2020 openEuler Buildteam <buildteam@openeuler.org> - 1.0-30
- add color aliases

* Tue Mar 17 2020 openEuler Buildteam <buildteam@openeuler.org> - 1.0-29
- fix changelog

* Sun Mar 15 2020 openEuler Buildteam <buildteam@openeuler.org> - 1.0-28
- add base

* Sat Mar 14 2020 openEuler Buildteam <buildteam@openeuler.org> - 1.0-27
- fix obs build problem

* Sat Mar 14 2020 openEuler Buildteam <buildteam@openeuler.org> - 1.0-26
- fix install problem

* Fri Mar 13 2020 openEuler Buildteam <buildteam@openeuler.org> - 1.0-25
- add performance script,close transparent_hugepage,change vm.min_free_kbytes=112640,export GOMP_CPU_AFFINITY
- close autogroup

* Tue Mar 3 2020 openEuler Buildteam <buildteam@openeuler.org> - 1.0-24
- remove unnecessary swap file

* Tue Mar 3 2020 openEuler Buildteam <buildteam@openeuler.org> - 1.0-23
- fix welcome information

* Tue Jan 7 2020 openEuler Buildteam <buildteam@openeuler.org> - 1.0-22
- fix welcome information

* Fri Dec 27 2019 openEuler Buildteam <buildteam@openeuler.org> - 1.0-21
- Delete unneeded info

* Mon Dec 23 2019 openEuler Buildteam <buildteam@openeuler.org> - 1.0-20
- Delete unneeded provides

* Thu Dec 19 2019 openEuler Buildteam <buildteam@openeuler.org> - 1.0-19
- Delete unneeded message

* Tue Oct 15 2019 fanghuiyu <fanghuiyu@huawei.com> - 1.0-18
- Change to generic-release

* Fri Sep 20 2019 hexiaowen <hexiaowen@huawei.com> - 1.0-17
- Provides generic-release

* Sat Aug 31 2019 hexiaowen <hexiaowen@huawei.com> - 1.0-16
- add eula.US

* Mon Aug 26 2019 zhangrui <zhangrui182@huawei.com> - 1.0-15
- Add system-info.sh to /etc/profile.d/ to show some information in welcome screen

* Thu Aug 22 2019 hexiaowen <hexiaowen@huawei.com> - 1.0-14
- add License

* Thu Aug 8 2019 openEuler Buildteam <buildteam@openeuler.org> - 1.0-13
- Package init
